package hdl

import (
	"applet/app/customer/md"
	"applet/app/customer/svc"
	"applet/app/db"
	"applet/app/e"
	"applet/app/enum"
	"applet/app/utils"
	"github.com/gin-gonic/gin"
)

func EducateSceneTokenQuery(c *gin.Context) {
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userToken := c.DefaultQuery("user_token", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}
	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	sysCfgDb := db.SysCfgDb{}
	sysCfgDb.Set()
	sysCfg := sysCfgDb.SysCfgFindWithDb(enum.OpenAppletAppid, enum.OpenAppletAppPrivateKey, enum.OpenAppletPublicKey)
	var certType string
	switch identity.CertType {
	case enum.UserIdentityCertTypeForIdCard:
		certType = "1"
	case enum.UserIdentityCertTypeForStudentId:
		certType = "X"
	case enum.UserIdentityCertTypeForPassport:
		certType = "A"
	}
	err, info := svc.CurlEducateSceneTokenQuery(md.CurlEducateSceneTokenReq{
		Config: struct {
			AliAppId      string `json:"ali_app_id" label:"支付宝开放平台-小程序-appid"`
			AliPrivateKey string `json:"ali_private_key" label:"支付宝开放平台-小程序-应用私钥"`
			AliPublicKey  string `json:"ali_public_key" label:"支付宝开放平台-小程序-支付宝公钥"`
		}{
			AliAppId:      sysCfg[enum.OpenAppletAppid],
			AliPrivateKey: sysCfg[enum.OpenAppletAppPrivateKey],
			AliPublicKey:  sysCfg[enum.OpenAppletPublicKey],
		},
		CertType:      certType,
		CertNo:        identity.IdNo,
		StudentName:   identity.Name,
		OutUserId:     utils.IntToStr(identity.Id),
		SchoolStdCode: selfSupportForSchoolInfo.SchoolStdCode,
	}, identity, userToken, selfSupportForSchoolInfo.Memo)
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}

func EducateSceneTokenCreateForApplet(c *gin.Context) {
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}
	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	sysCfgDb := db.SysCfgDb{}
	sysCfgDb.Set()
	sysCfg := sysCfgDb.SysCfgFindWithDb(enum.OpenAppletAppid, enum.OpenAppletAppPrivateKey, enum.OpenAppletPublicKey)
	var certType string
	switch identity.CertType {
	case enum.UserIdentityCertTypeForIdCard:
		certType = "1"
	case enum.UserIdentityCertTypeForStudentId:
		certType = "X"
	case enum.UserIdentityCertTypeForPassport:
		certType = "A"
	}
	err, info := svc.CurlEducateSceneTokenCreateForApplet(md.CurlEducateSceneTokenReq{
		Config: struct {
			AliAppId      string `json:"ali_app_id" label:"支付宝开放平台-小程序-appid"`
			AliPrivateKey string `json:"ali_private_key" label:"支付宝开放平台-小程序-应用私钥"`
			AliPublicKey  string `json:"ali_public_key" label:"支付宝开放平台-小程序-支付宝公钥"`
		}{
			AliAppId:      sysCfg[enum.OpenAppletAppid],
			AliPrivateKey: sysCfg[enum.OpenAppletAppPrivateKey],
			AliPublicKey:  sysCfg[enum.OpenAppletPublicKey],
		},
		CertType:      certType,
		CertNo:        identity.IdNo,
		StudentName:   identity.Name,
		OutUserId:     utils.IntToStr(identity.Id),
		SchoolStdCode: selfSupportForSchoolInfo.SchoolStdCode,
	})
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}

func EducateFacepayApply(c *gin.Context) {
	faceOpenId := c.DefaultQuery("face_open_id", "")
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}

	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	sysCfgDb := db.SysCfgDb{}
	sysCfgDb.Set()
	sysCfg := sysCfgDb.SysCfgFindWithDb(enum.OpenAppletAppid, enum.OpenAppletAppPrivateKey, enum.OpenAppletPublicKey)

	selfSupportForUserFaceInfoDb := db.SelfSupportForUserFaceInfoDb{}
	selfSupportForUserFaceInfoDb.Set(utils.StrToInt(userIdentityId))
	faceInfo, err := selfSupportForUserFaceInfoDb.GetSelfSupportForUserFaceInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if faceInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前用户身份未查询到一脸通行相关数据")
		return
	}
	err, info := svc.CurlEducateFacepayApply(md.CurlEducateFacepayApplyReq{
		Config: struct {
			AliAppId      string `json:"ali_app_id" label:"支付宝开放平台-小程序-appid"`
			AliPrivateKey string `json:"ali_private_key" label:"支付宝开放平台-小程序-应用私钥"`
			AliPublicKey  string `json:"ali_public_key" label:"支付宝开放平台-小程序-支付宝公钥"`
		}{
			AliAppId:      sysCfg[enum.OpenAppletAppid],
			AliPrivateKey: sysCfg[enum.OpenAppletAppPrivateKey],
			AliPublicKey:  sysCfg[enum.OpenAppletPublicKey],
		},
		FaceUid:       faceInfo.UserId,
		FaceOpenId:    faceOpenId,
		SchoolStdCode: selfSupportForSchoolInfo.SchoolStdCode,
	})
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}

func EducateSceneTokenCreateForConcentratedCollectApplet(c *gin.Context) {
	user := svc.GetUser(c)
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}

	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	sysCfgDb := db.SysCfgDb{}
	sysCfgDb.Set()
	sysCfg := sysCfgDb.SysCfgFindWithDb(enum.OpenAppletAppid, enum.OpenAppletAppPrivateKey, enum.OpenAppletPublicKey)
	var certType string
	switch identity.CertType {
	case enum.UserIdentityCertTypeForIdCard:
		certType = "1"
	case enum.UserIdentityCertTypeForStudentId:
		certType = "X"
	case enum.UserIdentityCertTypeForPassport:
		certType = "A"
	}
	err, info := svc.CurlEducateSceneTokenCreateForConcentratedCollectApplet(md.CurlEducateSceneTokenReq{
		Config: struct {
			AliAppId      string `json:"ali_app_id" label:"支付宝开放平台-小程序-appid"`
			AliPrivateKey string `json:"ali_private_key" label:"支付宝开放平台-小程序-应用私钥"`
			AliPublicKey  string `json:"ali_public_key" label:"支付宝开放平台-小程序-支付宝公钥"`
		}{
			AliAppId:      sysCfg[enum.OpenAppletAppid],
			AliPrivateKey: sysCfg[enum.OpenAppletAppPrivateKey],
			AliPublicKey:  sysCfg[enum.OpenAppletPublicKey],
		},
		CertType:       certType,
		CertNo:         identity.IdNo,
		StudentName:    identity.Name,
		OutUserId:      utils.IntToStr(identity.Id),
		SchoolStdCode:  selfSupportForSchoolInfo.SchoolStdCode,
		OperatorUserId: user.UserId,
	})
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}

func ConcentrateFacePassStudentList(c *gin.Context) {
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	page := utils.StrToInt(c.DefaultQuery("page", "1"))
	if page == 0 {
		page = 1
	}
	limit := utils.StrToInt(c.DefaultQuery("limit", "10"))
	if limit == 0 {
		limit = 10
	}
	concentrateSchoolFacePassStatus := c.DefaultQuery("concentrate_school_face_pass_status", "")

	var m []*db.SelfSupportForUserFaceInfoWithUserIdentity
	sess := db.Db.Where("self_support_for_user_face_info.enterprise_id =?", identity.EnterpriseId).And("self_support_for_user_face_info.collect_face_type =?", 2) //集采
	if concentrateSchoolFacePassStatus != "" {
		sess.And("self_support_for_user_face_info.concentrate_school_face_pass_status =?", concentrateSchoolFacePassStatus)
	}
	total, err := sess.Desc("self_support_for_user_face_info.id").
		Join("LEFT", "user_identity", "self_support_for_user_face_info.user_identity_id = user_identity.id").
		Limit(limit, (page-1)*limit).FindAndCount(&m)
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	type ConcentrateFacePassStudentListResp struct {
		UserIdentityId                  int    `json:"user_identity_id" label:"身份id"`
		Name                            string `json:"name" label:"姓名"`
		IdNo                            string `json:"id_no" label:"身份证号码"`
		ConcentrateSchoolFacePassStatus int    `json:"concentrate_school_face_pass_status" label:"校园一脸通行集采状态(1:待采集 2:待确认 3:已确认)"`
	}
	var resp []*ConcentrateFacePassStudentListResp
	for _, v := range m {
		resp = append(resp, &ConcentrateFacePassStudentListResp{
			UserIdentityId:                  v.UserIdentity.Id,
			Name:                            v.UserIdentity.Name,
			IdNo:                            v.UserIdentity.IdNo,
			ConcentrateSchoolFacePassStatus: v.SelfSupportForUserFaceInfo.ConcentrateSchoolFacePassStatus,
		})
	}
	e.OutSuc(c, map[string]interface{}{
		"list":  resp,
		"total": total,
		"concentrate_school_face_pass_status_list": []map[string]interface{}{
			{
				"name":  enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatus.String(enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatusByWaitCollect),
				"value": enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatusByWaitCollect,
			},
			{
				"name":  enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatus.String(enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatusByWaitConfirm),
				"value": enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatusByWaitConfirm,
			},
			{
				"name":  enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatus.String(enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatusByAlreadyConfirm),
				"value": enum.SelfSupportForUserFaceInfoConcentrateSchoolFacePassStatusByAlreadyConfirm,
			},
		},
	}, nil)
	return
}

func ConcentrateFacePassStudentConfirm(c *gin.Context) {
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if identity == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前用户身份信息未查询到")
		return
	}
	selfSupportForUserFaceInfoDb := db.SelfSupportForUserFaceInfoDb{}
	selfSupportForUserFaceInfoDb.Set(identity.Id)
	info, err := selfSupportForUserFaceInfoDb.GetSelfSupportForUserFaceInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	info.ConcentrateSchoolFacePassStatus = 2 //待确认状态
	_, err = selfSupportForUserFaceInfoDb.SelfSupportForUserFaceInfoUpdate(info, "concentrate_school_face_pass_status")
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	e.OutSuc(c, "success", nil)
	return
}
