package model

type CentralKitchenForSchoolSet struct {
	Id                                 int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	EnterpriseId                       int    `json:"enterprise_id" xorm:"not null default 0 comment('所属单位id') INT(11)"`
	IsOpenTeacherReportMeal            int    `json:"is_open_teacher_report_meal" xorm:"not null default 1 comment('教师报餐(1:开启 2:关闭)') TINYINT(1)"`
	IsOpenReportMealForDay             int    `json:"is_open_report_meal_for_day" xorm:"not null default 1 comment('开启学生按天报餐(1:开启 2:关闭)') TINYINT(1)"`
	IsOpenReportMealForMonth           int    `json:"is_open_report_meal_for_month" xorm:"not null default 1 comment('开启学生按月报餐(1:开启 2:关闭)') TINYINT(1)"`
	IsOpenReportMealForSemester        int    `json:"is_open_report_meal_for_semester" xorm:"not null default 1 comment('开启学生按学期报餐(1:开启 2:关闭)') TINYINT(1)"`
	IsOpenTeacherReportMealForDay      int    `json:"is_open_teacher_report_meal_for_day" xorm:"not null default 1 comment('开启按天教师报餐(1:开启 2:关闭)') TINYINT(1)"`
	IsOpenTeacherReportMealForMonth    int    `json:"is_open_teacher_report_meal_for_month" xorm:"not null default 1 comment('开启按月教师报餐(1:开启 2:关闭)') TINYINT(1)"`
	IsOpenTeacherReportMealForSemester int    `json:"is_open_teacher_report_meal_for_semester" xorm:"not null default 1 comment('开启按学期教师报餐(1:开启 2:关闭)') TINYINT(1)"`
	CreateAt                           string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt                           string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
